<template>
	<div id="checkin">
		<div id="messageArea">{{ message }}</div>
		<v-select v-model="selectedEvent" class="a-selector" solo :items="events" label="Event"></v-select>
		<v-text-field v-model="memberEmail" class="a-text-field" label="email" placeholder="Email" solo></v-text-field>
		<v-btn v-on:click="checkIn" class="a-btn" color="white">CHECK IN</v-btn>
		<br>
		<v-btn v-on:click="signOut" class="a-btn" color="white">SIGN OUT</v-btn>
	</div>
</template>

<script>
	const fb = require('../firebaseConfig.js');

	export default {
		name: 'Checkin',
		data() {
			return {
				events: [],
				selectedEvent: null,
				memberEmail: null,
				message: "Start checking in some users!"
			}
		},
		created() {
			const queryRef = fb.eventsCollection.where('month','==',12).where('day', '==', 16).where('year', '==', 2018);
			queryRef.get().then((querySnapshot) => {
				querySnapshot.forEach((doc) => {
					const amount = querySnapshot.size;
					this.events.push({value: doc.id, text: doc.data().name});
				});
			}).catch((error) => {
				console.log(error.message);
			});
		},
		methods: {
			signOut() {
				fb.auth.signOut().then(() => {
					this.$router.push("/login");
				}).catch((error) => {
					console.log(error.message);
				});
			},
			checkIn() {
				const selectedEventUid = this.selectedEvent;
				const memberEmail = this.memberEmail;
				const queryRef = fb.eventsCollection.doc(selectedEventUid).collection('registrants').where('email', '==', memberEmail);
				queryRef.get().then((querySnapshot) => {
					const amount = querySnapshot.size;
					if (amount === 0) {
						this.message = "Email is not registered for this event";
					} else {
						querySnapshot.forEach((doc) => {
							const docUid = doc.id;
							if (doc.data().checkedIn === true) {
								this.message = "Member is already checked in for this event";
							} else {
								const writeQueryRef = fb.eventsCollection.doc(selectedEventUid).collection('registrants').doc(docUid);
								writeQueryRef.update({checkedIn: true}).then(() => {
									this.message = "Successful check in!";
								}).catch((error) => {
									this.message = "505: " + error.message; 
								});
							}
						});
					}
				}).catch((error) => {
					this.message = "505: " + error.message; 
				});
			}
		}
	}
</script>

<style scoped>
	#checkin {
		padding-top: 20px;
		margin-top: 25px;
		color: white;
		text-align: center;
		background-color: orange;
	}

	.a-btn {
		width: 70%;
		margin: 0 auto;
		color: orange;
		margin-bottom: 15px;
		height: 50px;
	}

	.a-selector {
		width: 90%;
		margin: 0 auto;
	}

	.a-text-field {
		width: 90%;
		margin: 0 auto;
	}

	#messageArea {
		text-align: center;
		color: white;
		font-weight: 700;
		margin-bottom: 20px;
		margin-top: 10px;
	}

	#error-message {
		color: red;
		text-align: center;
		margin-top: 50px;
	}
</style>
